(PackageInfo named: 'Relationships') postscriptOfRemoval: '"below, add code to clean up after the unloading of this package"
Class removeInstVarName: ''relationships''.'!
(PackageInfo named: 'Relationships') preamble: '"below, add code to be run before the loading of this package"
| relationship |
relationship := ''relationships''.
(Class instVarNames contains: [:each | (each = relationship)] )
	ifFalse: [Class addInstVarName: relationship]. '!
SystemOrganization addCategory: #'Relationships-Tests'!
SystemOrganization addCategory: #Relationships!
SystemOrganization addCategory: #'Relationships-Benchmark'!
SystemOrganization addCategory: #'Relationships-Examples'!

Browser subclass: #RelationshipBrowser
	instanceVariableNames: 'relationshipsIndicated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 11:04:26.856'!
aboutToStyle: aStyler
	"This is a notification that aStyler is about to re-style its text.
	Set the classOrMetaClass in aStyler, so that identifiers
	will be resolved correctly.
	Answer true to allow styling to proceed, or false to veto the styling"
	self relationshipsIndicated ifTrue: 
		[aStyler classOrMetaClass: nil.
		^ true].
	^ super aboutToStyle: aStyler.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:59:47.952'!
asDescription: aRelationship
	"Returns the instance variables of the relationship as a description that can be displayed in the editor"

	| relationship |
	relationship := self selectedRelationship.
	^  'OneToManyRelationship named: #', relationship relationshipName , '
	leftClass: ', relationship leftClass , '
	rightClass: ', relationship rightClass.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 10:30:55.646'!
buildSwitchesWith: builder
	"Build the instance/comment/class switch"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'instance'; 
			state: #instanceMessagesIndicated; 
			action: #indicateInstanceMessages;
			frame: (0@0 corner: 0.39@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '?'; 
			state: #classCommentIndicated; 
			action: #plusButtonHit;
			frame: (0.41@0 corner: 0.59@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'class'; 
			state: #classMessagesIndicated; 
			action: #indicateClassMessages;
			frame: (0.61@0 corner: 0.79@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '-->'; 
			state: #relationshipsIndicated; 
			action: #indicateRelationships;
			frame: (0.81@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^panelSpec! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:13:48.379'!
classMessagesIndicated
	self relationshipsIndicated 
		ifTrue: [^ false]
		ifFalse: [^ super classMessagesIndicated].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/17/2011 10:52:43.832'!
contents
	| |
	relationshipsIndicated ifFalse: 
		[^ super contents].
	self selectedMessageName ifNotNil: [^ self selectedRelationship definition].
	(messageCategoryListIndex = 2) ifTrue: 
			"One to One"
			[^ OneToOneRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	(messageCategoryListIndex = 3) ifTrue: 
			"One to Many"
			[^ OneToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	(messageCategoryListIndex = 4) ifTrue: 
			"Many to One"
			[^ OneToManyRelationship emptyDefinitionWithRightClassString: (self selectedClass name)].
	(messageCategoryListIndex = 5) ifTrue: 
			"Many to Many"
			[^ ManyToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	self selectedClass ifNotNil: 
		[^ OneToManyRelationship emptyDefinitionWithLeftClassString: (self selectedClass name)].
	^ OneToManyRelationship emptyDefinition.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 00:34:19.477'!
contents: input notifying: aController 
	"Save the contents"
	| relationship |
	relationshipsIndicated ifFalse: 
		[^ super contents: input notifying: aController.].
	relationship := Compiler evaluate: input "notifying: aController logged: false".
	relationship activate.
	self clearUserEditFlag.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 10:27:53.29'!
defaultBrowserTitle
	^ 'Relationship Browser'! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:23:59.754'!
indicateRelationships
	relationshipsIndicated := true.
	self changed: #classSelectionChanged.
	self changed: #messageCategoryList.
	self changed: #messageList.
	self changed: #contents.
	self changed: #annotation.
	self decorateButtons.
	^ relationshipsIndicated.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:13:42.409'!
instanceMessagesIndicated
	self relationshipsIndicated 
		ifTrue: [^ false]
		ifFalse: [^ super instanceMessagesIndicated].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/24/2010 00:32:54.295'!
messageCategoryList
	"Answer the selected category of messages."
	relationshipsIndicated ifFalse: 
		[^ super messageCategoryList].
	classListIndex = 0
		ifTrue: 
			[^ Array new]
		ifFalse: 
			[^ #('-- all --' 'OneToOne' 'OneToMany' 'ManyToOne' 'ManyToMany') ].
			"[^ self selectedClass relationships keys copy ]."! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/17/2011 10:34:26.498'!
messageList
	"Answer the selected category of messages."
	| collection |
	relationshipsIndicated ifFalse: 
		[^ super messageList].
	collection := OrderedCollection new.
	(messageCategoryListIndex = 0) | (messageCategoryListIndex = 1)
		ifTrue: 
			"No selection or all"
			[self selectedClass ifNotNil: [^ self selectedClass relationships keys copy].
			^ collection asArray.]
		ifFalse: 
			[
			"One to one"
			(messageCategoryListIndex = 2) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToOneRelationship ifTrue: 
						[collection add: each relationshipName]
					].
				].
			"One to many"
			(messageCategoryListIndex = 3) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToManyRelationship ifTrue: 
						[each oneClass = self selectedClass ifTrue: 
							[collection add: each relationshipName]
							"[collection add: each shortDefinition]"
						] 
					].
				].
			"Many to one"
			(messageCategoryListIndex = 4) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isOneToManyRelationship ifTrue: 
						[each manyClass = self selectedClass ifTrue: 
							[collection add: each relationshipName]
						] 
					].
				].
			"Many to many"
			(messageCategoryListIndex = 5) ifTrue: 
				[self selectedClass relationships do: 
					[ :each | each isManyToManyRelationship ifTrue: 
						[collection add: each relationshipName]
					].
				].
			^ collection asArray.
			].! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/27/2010 11:25:27.859'!
metaClassIndicated: trueOrFalse
	"Is called both for instance and class indication. Unset the relationship indicator."
	relationshipsIndicated := false.
	^ super metaClassIndicated: trueOrFalse.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 12/24/2010 00:03:22.31'!
relationshipsIndicated
	relationshipsIndicated ifNil: [relationshipsIndicated := false].
	^ relationshipsIndicated.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 00:40:53.277'!
removeMessage
	"Remove a relationship"
	| |
	self relationshipsIndicated ifFalse: [^ super removeMessage].
	messageListIndex = 0
		ifTrue: [^ self].
	self okToChange
		ifFalse: [^ self].
	self selectedRelationship remove.
	self messageListIndex: 0.
	self changed: #messageList.
	self setClassOrganizer.! !

!RelationshipBrowser methodsFor: 'as yet unclassified' stamp: 'cn 1/3/2011 14:59:27.95'!
selectedRelationship
	"return the selected relationship"
	self selectedMessageName ifNil: [^ nil].
	^ self selectedClass relationships at: self selectedMessageName.! !

Object subclass: #Bouquet
	instanceVariableNames: 'price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Examples'!

Object subclass: #Child
	instanceVariableNames: 'generatedFather'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!Child methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:34:34.337'!
father
			^generatedFather.! !

!Child methodsFor: 'accessing' stamp: 'cn 1/13/2011 15:17:05.535'!
mother
			^generatedMother.! !

!Child methodsFor: 'accessing' stamp: 'cn 1/13/2011 15:17:05.591'!
mother: anObject
		| oldObject |
		anObject = generatedMother ifTrue: [^ self].
		oldObject := generatedMother.
		generatedMother := anObject.
		oldObject ifNotNil: [oldObject removeDaughter: self].
		anObject ifNotNil: [
		(anObject daughters contains: [:item | item = self]) 
			ifFalse: [anObject addDaughter: self]
		]! !

Object subclass: #DBDictionary
	instanceVariableNames: 'root children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

!DBDictionary methodsFor: 'accessing' stamp: 'cn 1/12/2011 23:45:52.551'!
addChild: child
	children ifNil: [children := OrderedCollection new.].
	children add: child.! !

!DBDictionary methodsFor: 'accessing' stamp: 'cn 1/12/2011 23:36:54.748'!
children
	"Answer the value of children"

	^ children! !

!DBDictionary methodsFor: 'accessing' stamp: 'cn 1/12/2011 23:36:54.645'!
root
	"Answer the value of root"

	^ root! !

!DBDictionary methodsFor: 'accessing' stamp: 'cn 1/12/2011 23:36:54.703'!
root: anObject
	"Set the value of root"

	root := anObject! !

Object subclass: #DBRow
	instanceVariableNames: 'root child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

!DBRow methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:46:15.41'!
child
	"Answer the value of child"

	^ child! !

!DBRow methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:46:15.466'!
child: anObject
	"Set the value of child"

	child := anObject! !

!DBRow methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:46:15.249'!
root
	"Answer the value of root"

	^ root! !

!DBRow methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:46:15.355'!
root: anObject
	"Set the value of root"

	root := anObject! !

Object subclass: #Flower
	instanceVariableNames: 'name price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Examples'!

Object subclass: #FlowerCategory
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Examples'!

Object subclass: #GreetingCard
	instanceVariableNames: 'picture text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Examples'!

Object subclass: #Parent
	instanceVariableNames: 'generatedSons generatedChilds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:35:12.794'!
addChild: anObject
			((anObject parent = nil) or: (anObject parent = self)) ifFalse:
				[anObject parent removeChild: anObject].
			generatedChilds ifNil: [generatedChilds := OrderedCollection new].
			generatedChilds add: anObject.
			anObject instVarNamed: 'generatedParent' put: self.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/13/2011 15:17:05.169'!
addDaughter: anObject
			generatedDaughters ifNil: [generatedDaughters := OrderedCollection new].
			generatedDaughters add: anObject.
			anObject instVarNamed: 'generatedMother' put: self.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:34:33.852'!
addSon: anObject
			((anObject father = nil) or: (anObject father = self)) ifFalse:
				[anObject father removeSon: anObject].
			generatedSons ifNil: [generatedSons := OrderedCollection new].
			generatedSons add: anObject.
			anObject instVarNamed: 'generatedFather' put: self.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:35:12.736'!
childs
			generatedChilds ifNil: [generatedChilds := OrderedCollection new].
			^ generatedChilds copy! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/13/2011 15:17:05.072'!
daughters
			generatedDaughters ifNil: [generatedDaughters := OrderedCollection new].
			^ generatedDaughters copy! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:35:12.847'!
removeChild: anObject
			generatedChilds ifNotNil: [generatedChilds remove: anObject ifAbsent: [^false.] ].
			anObject parent  = self ifTrue: [anObject instVarNamed: 'generatedParent' put: nil].
			^true.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/13/2011 15:17:05.226'!
removeDaughter: anObject
			generatedDaughters ifNotNil: [generatedDaughters remove: anObject ifAbsent: [^false.] ].
			anObject mother  = self ifTrue: [anObject instVarNamed: 'generatedMother' put: nil].
			^true.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:34:33.899'!
removeSon: anObject
			generatedSons ifNotNil: [generatedSons remove: anObject ifAbsent: [^false.] ].
			anObject father  = self ifTrue: [anObject instVarNamed: 'generatedFather' put: nil].
			^true.! !

!Parent methodsFor: 'accessing' stamp: 'cn 1/16/2011 13:34:33.793'!
sons
			generatedSons ifNil: [generatedSons := OrderedCollection new].
			^ generatedSons copy! !

Object subclass: #RelationshipDescription
	instanceVariableNames: 'relationshipName leftClass leftClassName rightClass rightClassName isBidirectional'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

RelationshipDescription subclass: #ManyToManyRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!ManyToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/17/2011 10:50:03.269'!
isManyToManyRelationship
	^ true.! !

RelationshipDescription subclass: #OneToManyRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/6/2011 14:46:19.092'!
activate
	self checkIfParametersForActivateAreSet.
	"Add to the classes"
	leftClass addRelationship: self.
	self isBidirectional ifTrue: [rightClass addRelationship: self].
	"Generate methods"
	self 
		generateInstVarOneClass; 
		generateMethodsOneClass.
	self isBidirectional ifTrue: [
		self 
			generateInstVarManyClass;
			generateMethodsManyClass].! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/5/2011 14:31:40.028'!
generateInstVarManyClass
	"Generates the instance variable."
	| instVarName |
	"Names"
	instVarName := self instVarNameManyClass .
	"Instance var"
	(rightClass instVarNames contains: [:each | (each = instVarName)] ) ifFalse: [rightClass addInstVarName: instVarName].! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/5/2011 13:59:25.356'!
generateInstVarOneClass
	"Generates the instance variable."
	| instVarName |
	"Names"
	instVarName := self instVarNameOneClass .
	"Instance var"
	(leftClass instVarNames contains: [:each | (each = instVarName)] ) ifFalse: [leftClass addInstVarName: instVarName].
	! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/13/2011 15:22:12.398'!
generateMethodsManyClass
	"Generates the methods. Needs to be called after the instance variable has been created."
	self getterManyClass.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 12/13/2010 14:37:37.276'!
generateMethodsOneClass
	"Generates the methods. Needs to be called after the instance variable has been created."

	self getterOneClass;
		setterOneClass;
		removeOneClass.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/5/2011 14:31:39.971'!
getterManyClass
	| template |
	"Getter"
	template := (Template new)
		template: '{methodName}
			^{instVarName}.';
		methodName: self getterNameManyClass;
		instVarName: self instVarNameManyClass.
	rightClass compile: template apply classified: #accessing.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 12/8/2010 23:00'!
getterNameManyClass
	^ self varNameManyClass.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/6/2011 10:56:07.819'!
getterNameOneClass
	^ self varNameOneClass , 's'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/5/2011 19:11:58.879'!
getterOneClass
	| template |
	"Getter"
	template := (Template new)
		template:
				'{methodName}
			{instVarName} ifNil: [{instVarName} := OrderedCollection new].
			^ {instVarName} copy';
		methodName: self getterNameOneClass;
		instVarName: self instVarNameOneClass.
	leftClass compile: template apply classified: #accessing! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 12/8/2010 23:27'!
instVarNameManyClass
	^ 'generated', (self varNameManyClass capitalized).! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/6/2011 10:57:06.79'!
instVarNameOneClass
	^ 'generated', (self varNameOneClass capitalized) , 's'.! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:56:14.233'!
isOneToManyRelationship
	^ true.! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:31:39.583'!
manyClass
	"Answer the value of manyClass"

	^ rightClass! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:31:39.915'!
manyClass: anObject
	"Set the value of manyClass"
	rightClass := anObject.	! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/5/2011 13:59:25.187'!
oneClass
	"Answer the value of oneClass"

	^ leftClass! !

!OneToManyRelationship methodsFor: 'accessing' stamp: 'cn 1/5/2011 13:59:25.066'!
oneClass: anObject
	"Set the value of oneClass"
	leftClass :=  anObject.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/6/2011 14:11:48.65'!
remove
	"Remove methods"
	self 
		removeMethodsOneClass; 
		removeInstVarOneClass;
		removeMethodsManyClass; 
		removeInstVarManyClass.
	"Remove self from relationship dictionary"
	leftClass removeRelationship: self.
	rightClass removeRelationship: self.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/5/2011 14:31:39.847'!
removeInstVarManyClass
	"Remove instance var"
	rightClass removeInstVarName: self instVarNameManyClass.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/5/2011 13:59:25.13'!
removeInstVarOneClass
	"Remove instance var"
	leftClass removeInstVarName: self instVarNameOneClass.! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/5/2011 14:31:40.138'!
removeMethodsManyClass
	"Getter"
	rightClass removeSelector: (self getterNameManyClass asSymbol).
	"Setter"
	rightClass removeSelector: (self setterNameManyClass asSymbol).! !

!OneToManyRelationship methodsFor: 'removing' stamp: 'cn 1/5/2011 13:59:25.578'!
removeMethodsOneClass
	"Getter"
	leftClass removeSelector: self getterNameOneClass asSymbol.
	"Setter"
	leftClass removeSelector: self setterNameOneClass asSymbol.
	"Remove"
	leftClass removeSelector: self removeNameOneClass asSymbol.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/6/2011 10:55:28.108'!
removeNameOneClass
	^ 'remove', (self varNameOneClass capitalized), ':'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/13/2011 15:15:54.691'!
removeOneClass
	"Remove"
 	| template |
	template := Template new
		template: '{methodName} anObject
			{instVarName} ifNotNil: [{instVarName} remove: anObject ifAbsent: [^false.] ].
			anObject {getterMethod}  = self ifTrue: [anObject instVarNamed: ''{manyInstVarName}'' put: nil].
			^true.';
			methodName: self removeNameOneClass;
			instVarName: self instVarNameOneClass;
			getterMethod: self getterNameManyClass;
			manyInstVarName: self instVarNameManyClass.
	leftClass compile: template apply classified: #accessing.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/5/2011 14:31:39.736'!
setterManyClass
	"Setter"
 	| template |
	template := Template new
	template: '{methodName} anObject
		| oldObject |
		anObject = {instVarName} ifTrue: [^ self].
		oldObject := {instVarName}.
		{instVarName} := anObject.
		oldObject ifNotNil: [oldObject {removeMethod} self].
		anObject ifNotNil: [
		(anObject {getterMethod} contains: [:item | item = self]) 
			ifFalse: [anObject {setterMethod} self]
		]';
		methodName: self setterNameManyClass;
		instVarName: self instVarNameManyClass;
		removeMethod: self removeNameOneClass;
		getterMethod: self getterNameOneClass;
		setterMethod: self setterNameOneClass.
	rightClass compile: template apply classified: #accessing.
	! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 12/8/2010 23:19'!
setterNameManyClass
	^ (self varNameManyClass, ':').! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/6/2011 10:55:18.911'!
setterNameOneClass
	^ 'add', (self varNameOneClass capitalized), ':'.! !

!OneToManyRelationship methodsFor: 'generating' stamp: 'cn 1/13/2011 16:04:16.014'!
setterOneClass
	"Setter"
 	| template |
	template := Template new
		template: '{methodName} anObject
			((anObject {getterManyClass} = nil) or: (anObject {getterManyClass} = self)) ifFalse:
				[anObject {getterManyClass} {removeMethod} anObject].
			{instVarName} ifNil: [{instVarName} := OrderedCollection new].
			{instVarName} add: anObject.
			anObject instVarNamed: ''{manyInstVarName}'' put: self.';
			getterManyClass: self getterNameManyClass;
			removeMethod: self removeNameOneClass;
			methodName: self setterNameOneClass;
			instVarName: self instVarNameOneClass;
			manyInstVarName: self instVarNameManyClass.
		leftClass compile: template apply classified: #accessing.
	! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/5/2011 18:46:21.76'!
varNameManyClass
	^ self varNameUsedInRightClass.! !

!OneToManyRelationship methodsFor: 'names' stamp: 'cn 1/6/2011 10:56:02.183'!
varNameOneClass
	^ self varNameUsedInLeftClass.! !

RelationshipDescription subclass: #OneToOneRelationship
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!OneToOneRelationship methodsFor: 'accessing' stamp: 'cn 1/17/2011 10:49:06.953'!
isOneToOneRelationship
	^ true.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/16/2011 13:01:05.367'!
definitionTemplate
	| template |
	template := Template new.
	template template: 
	'{relationshipType} named: #{relationshipName}
	leftClass: {leftClass}
	leftClassName: {leftClassName}
	rightClass: {rightClass}
	rightClassName: {rightClassName}
	isBidirectional: {isBidirectional}'.
	^ template.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/16/2011 13:20:50.974'!
emptyDefinition
	"Definition of the class as a string"
	^ self emptyDefinitionWithLeftClassString: 'YourClass'.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/16/2011 13:20:26.447'!
emptyDefinitionWithLeftClassString: aString
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self class name;
		relationshipName: 'aName';
		leftClass: aString;
		leftClassName: 'nil';
		rightClass: 'YourOtherClass';
		rightClassName: 'nil';
		isBidirectional: true asString.
	^ template apply.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/17/2011 10:36:18.522'!
emptyDefinitionWithRightClassString: aString
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self class name;
		relationshipName: 'aName';
		leftClass: 'YourOtherClass';
		leftClassName: 'nil';
		rightClass: aString;
		rightClassName: 'nil';
		isBidirectional: true asString.
	^ template apply.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 23:22:48.761'!
named: aName leftClass: leftClass leftClassName: leftName rightClass: rightClass rightClassName: rightName
	"Create a new relationship"
	| relationship |
	relationship := self named: aName leftClass: leftClass rightClass: rightClass.
	relationship
		leftClassName: leftName;
		rightClassName: rightName.
	^ relationship.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/16/2011 13:14:03.544'!
named: aName leftClass: leftClass leftClassName: leftName rightClass: rightClass rightClassName: rightName isBidirectional: isBidirectional
	"Create a new relationship"
	| relationship |
	relationship := self named: aName leftClass: leftClass rightClass: rightClass.
	relationship
		leftClassName: leftName;
		rightClassName: rightName;
		isBidirectional: isBidirectional.
	^ relationship.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 23:30:57.936'!
named: aName leftClass: leftClass rightClass: rightClass
	"Find an existing relationship that fits to the name and at least one of the two classes or create a new relationship"
	| relationship |
	relationship := leftClass relationships at: aName ifAbsent: 
		[rightClass relationships at: aName ifAbsent:
			[self newWithName: aName leftClass: leftClass rightClass: rightClass].
		].
	"In case one of the classes has changed"
	relationship 
		leftClass: leftClass;
		rightClass: rightClass.
	^ relationship.! !

!RelationshipDescription class methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 14:13:21.61'!
newWithName: aName leftClass: leftClass rightClass: rightClass
	"Create a new relationship"
	| relationship |
	relationship := self new.
	relationship
		relationshipName: aName;
		leftClass: leftClass;
		rightClass: rightClass.
	^ relationship.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/8/2010 22:16'!
activate
	"generate methods and instance variables"
	self subclassResponsibility.! !

!RelationshipDescription methodsFor: 'private' stamp: 'cn 1/6/2011 14:47:20.014'!
checkIfParametersForActivateAreSet
	leftClass ifNil: [Error new signal].
	rightClass ifNil: [Error new signal].
	relationshipName ifNil: [Error new signal].! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/16/2011 12:53:10.612'!
classes
	"Classes that reference this relationship"
	| classes |
	classes := OrderedCollection new.
	classes add: leftClass.
	isBidirectional ifTrue: [classes add: rightClass].
	^ classes.! !

!RelationshipDescription methodsFor: 'definition' stamp: 'cn 1/16/2011 13:17:20.138'!
definition
	"Definition of the class as a string"
	| template |
	template := RelationshipDescription definitionTemplate.
	template relationshipType: self class name;
		relationshipName: self relationshipName;
		leftClass: self leftClass name;
		leftClassName: (self inQuotesIfNotNil: self leftClassName);
		rightClass: self rightClass name;
		rightClassName: (self inQuotesIfNotNil: self rightClassName);
		isBidirectional: self isBidirectional asString.
	^ template apply.! !

!RelationshipDescription methodsFor: 'private' stamp: 'cn 1/16/2011 13:13:08.013'!
inQuotesIfNotNil: aString
	"Put quotes around the string unless it is nil"
	aString ifNotNil: [^ '''', aString, ''''].
	^ 'nil'.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/16/2011 12:52:11.127'!
isBidirectional
	"Answer the value of isBidirectional"
	isBidirectional ifNil: [isBidirectional := true].
	^ isBidirectional! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/16/2011 12:52:24.593'!
isBidirectional: anObject
	"Set the value of isBidirectional"
	isBidirectional := anObject! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:56:00.857'!
isManyToManyRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:55:46.31'!
isOneToManyRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/24/2010 00:55:51.808'!
isOneToOneRelationship
	^ false.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.366'!
leftClass
	"Answer the value of leftClass"

	^ leftClass! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.438'!
leftClass: anObject
	"Set the value of leftClass"

	leftClass := anObject! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:18:13.448'!
leftClassName
	"Answer the name of leftClass that is used to generate the methodnames etc"

	^ leftClassName! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:16:23.458'!
leftClassName: anObject
	"Set the value of leftClassName"

	leftClassName := anObject! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 11/13/2010 15:55'!
relationshipName
	"Answer the value of relationshipName"

	^ relationshipName! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 11/13/2010 15:55'!
relationshipName: anObject
	"Set the value of relationshipName"

	relationshipName := anObject! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 12/8/2010 22:16'!
remove
	"generate methods and instance variables"
	self subclassResponsibility.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.504'!
rightClass
	"Answer the value of rightClass"

	^ rightClass! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 14:48:09.571'!
rightClass: anObject
	"Set the value of rightClass"

	rightClass := anObject! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:18:38.335'!
rightClassName
	"Answer the name of rightClass that is used to generate the methodnames etc"

	^ rightClassName! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:16:23.637'!
rightClassName: anObject
	"Set the value of rightClassName"

	rightClassName := anObject! !

!RelationshipDescription methodsFor: 'definition' stamp: 'cn 1/16/2011 13:33:46.55'!
shortDefinition
	| aString |
	self leftClassName ifNil: [aString := self leftClass name.]
		ifNotNil: [aString := self leftClassName, '(', self leftClass name, ')'.].
	self isBidirectional ifTrue: [aString := aString , '<->']
		ifFalse: [aString := aString, '->'].
	self rightClassName ifNil: [aString := aString, self rightClass name.]
		ifNotNil: [aString := aString, self rightClassName, '(', self rightClass name, ')'.].
	^ aString.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 19:11:22.479'!
varNameUsedInLeftClass
	"The name to be used for the instance vars and methods in the left class."
	self rightClassName ifNotNil: 
		"The user has set a name"
		[^ self rightClassName ].
	"Use the class name"
	^ ((rightClass name subStrings: ' ') at: 1) withFirstCharacterDownshifted.! !

!RelationshipDescription methodsFor: 'accessing' stamp: 'cn 1/5/2011 15:29:08.155'!
varNameUsedInRightClass
	"The name to be used for the instance vars and methods in the right class."
	self leftClassName ifNotNil: 
		"The user has set a name"
		[^ self leftClassName ].
	"Use the class name"
	^ ((leftClass name subStrings: ' ') at: 1) withFirstCharacterDownshifted.! !

Object subclass: #Template
	instanceVariableNames: 'aDictionary string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships'!

!Template class methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:03:11.839'!
insert: aDictionary into: aString 
	"Replace the keys found in aDictionary in aString with the values from aDictionary"
	^String new: aString size streamContents: [ :result |
		| stream currentChar |
		stream := aString readStream.
		[ (currentChar := stream next) == nil ] whileFalse: [
			currentChar == ${
				ifTrue: [
					result nextPutAll: (
						aDictionary at: (stream upTo: $})
						)]
				ifFalse: [
					currentChar == $\
						ifFalse: [ result nextPut: currentChar ]
						ifTrue: [
							(currentChar := stream next) ifNotNil: [
								result nextPut: currentChar ] ] ] ] ]! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:13:44.389'!
apply
	^Template insert: aDictionary into: string.! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:07:12.157'!
at: key put: value
	aDictionary ifNil: [aDictionary := Dictionary new.].
	aDictionary at: key put: value.! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 1/5/2011 13:37:25.49'!
doesNotUnderstand: aMessage
	"Implement a short notation that allows to fill the dictionary in a nicer fashion
	Old way: 	aTemplate at: 'value' put: aValue
	New way: 	aTemplate value: aValue"
	aMessage numArgs = 1 ifTrue: 
		[^ self at: aMessage selector asString onlyLetters put: aMessage argument]
	ifFalse: 
		[^ super doesNotUnderstand: aMessage].! !

!Template methodsFor: 'as yet unclassified' stamp: 'cn 12/13/2010 14:09:20.756'!
template: aString
	string := aString.! !

Object subclass: #TreeNodeAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

!TreeNodeAbstract class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:49:19.823'!
benchmark
	| rootNode result |
	"setup"
	self init.
	rootNode := self createNode.
	(1 to: 100) do: [:x | rootNode addChild: self createNode.].
	rootNode children do: [:child | (1 to: 10) do: [:x | child addChild: self createNode.].].
	"benchmark"
	MessageTally spyOn: [result := TreeNodeInstance recursiveTraversal: rootNode leafCounter: 0].
	Transcript show: result.! !

!TreeNodeAbstract class methodsFor: 'as yet unclassified' stamp: 'cn 1/10/2011 14:54:34.115'!
createNode
	self subclassResponsibility.! !

!TreeNodeAbstract class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 21:00:02.55'!
init! !

!TreeNodeAbstract class methodsFor: 'as yet unclassified' stamp: 'cn 1/10/2011 14:54:04.789'!
recursiveTraversal: aNode leafCounter: anInteger
	| newCount |
	aNode children ifNil: 
		[^ anInteger + 1].
	newCount := anInteger.
	aNode children do: 
		[:child | newCount := TreeNodeInstance recursiveTraversal: child leafCounter: newCount].
	^ newCount.! !

!TreeNodeAbstract methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:54:21.759'!
addChild: anObject
	self subclassResponsibility.! !

!TreeNodeAbstract methodsFor: 'accessing' stamp: 'cn 1/10/2011 14:54:28.778'!
children
	"Answer the value of children"

	self subclassResponsibility.! !

TreeNodeAbstract subclass: #TreeNodeDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

TreeNodeDB class
	instanceVariableNames: 'Relations'!

TreeNodeDB class
	instanceVariableNames: 'Relations'!

!TreeNodeDB class methodsFor: 'as yet unclassified' stamp: 'cn 1/10/2011 14:55:43.169'!
createNode
	^ TreeNodeDB new.! !

!TreeNodeDB class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 20:58:43.432'!
getRelationships
	^ Relations.! !

!TreeNodeDB class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 21:05:34.758'!
init
	Relations := OrderedCollection new.! !

!TreeNodeDB methodsFor: 'accessing' stamp: 'cn 1/12/2011 20:54:33.605'!
addChild: anObject
	"Set the value of children"
	| aRow| 
	aRow := DBRow new.
	aRow root: self;
		child: anObject.
	TreeNodeDB getRelationships add: aRow.! !

!TreeNodeDB methodsFor: 'accessing' stamp: 'cn 1/12/2011 20:54:22.361'!
children
	"Answer the value of children"
	| children |
	children := OrderedCollection new.
	TreeNodeDB getRelationships do: 
		[ :ea | ea root == self 
			ifTrue: [children add: ea child]
		].
	^ children.! !

TreeNodeDB subclass: #TreeNodeDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

!TreeNodeDictionary class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 21:31:39.108'!
createNode
	^ TreeNodeDictionary new.! !

!TreeNodeDictionary class methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:37:14.642'!
init
	Relations := OrderedCollection new.! !

!TreeNodeDictionary methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:47:33.479'!
addChild: anObject
	"Set the value of children"
	| | 
	self findDBDictionary addChild: anObject.! !

!TreeNodeDictionary methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:47:06.946'!
children
	"Set the value of children"
	^ self findDBDictionary children.! !

!TreeNodeDictionary methodsFor: 'as yet unclassified' stamp: 'cn 1/12/2011 23:46:39.554'!
findDBDictionary
	| dBDictionary |
	TreeNodeDictionary getRelationships do: [:dBDict | dBDict root = self ifTrue: [^ dBDict]].
	dBDictionary := DBDictionary new.
	dBDictionary root: self.
	TreeNodeDictionary getRelationships add: dBDictionary.
	^ dBDictionary.! !

TreeNodeAbstract subclass: #TreeNodeInstance
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Benchmark'!

!TreeNodeInstance class methodsFor: 'as yet unclassified' stamp: 'cn 1/10/2011 14:52:10.126'!
createNode
	^ TreeNodeInstance new.! !

!TreeNodeInstance methodsFor: 'accessing' stamp: 'cn 1/10/2011 10:55:11.412'!
addChild: anObject
	"Set the value of children"
	children = nil ifTrue: [children := OrderedCollection new.].
	children add: anObject.! !

!TreeNodeInstance methodsFor: 'accessing' stamp: 'cn 1/10/2011 10:35:37.048'!
children
	"Answer the value of children"

	^ children! !

TestCase subclass: #RelationshipTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTest methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 14:08:45.666'!
setUp
	| result |
	result := OneToManyRelationship newWithName: 'children' leftClass: Parent rightClass: Child.
	result isBidirectional: true.
	result activate.
	self should: ((Parent relationships at: 'children') = result).! !

!RelationshipTest methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 14:12:15.384'!
tearDown
	| relationship |
	relationship := Parent relationships at: 'children'.
	relationship remove.
	self should: ((Parent relationships at: 'children' ifAbsent: []) = nil).
	self should: ((Child relationships at: 'children' ifAbsent: []) = nil).
	! !

!RelationshipTest methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 15:23:28.338'!
testGeneratedClasses
	"Tests if all methods are there"
	self should: (Parent relationships includesKey: 'children').
	self should: (Parent methodDict includesKey: ('addChild:' asSymbol) ).
	self should: (Child relationships includesKey: 'children').
	self should: (Child methodDict includesKey: ('parent' asSymbol) ).! !

!RelationshipTest methodsFor: 'as yet unclassified' stamp: 'cn 1/13/2011 15:26:41.778'!
testGeneratedMethodsChildAccess
	"Test the methods that have been generated on the child side"
	| parent parent2 child |
	"Create child and parent"
	child := Child new.
	parent := Parent new.
	parent2 := Parent new.
	parent addChild: child.
	self should: (child parent = parent).
	self should: ((parent childs at: 1) = child).
	"Remove parent"
	parent removeChild: child.
	self should: (child parent = nil).
	"Switch parent"
	parent addChild: child.
	self should: (child parent = parent).
	self should: ((parent childs at: 1) = child).
	parent2 addChild: child.
	self should: (child parent = parent2).
	self should: ((parent childs size) = 0).
	self should: ((parent2 childs at: 1) = child).! !

!RelationshipTest methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 13:33:39.967'!
testGeneratedMethodsParentAccess
	"Test the methods that have been generated on the parent side"
	| result parent child |
	"Create parent"
	parent := Parent new.
	self should: parent childs size = 0.
	"Add child to parent"
	parent addChild: Child new.
	self should: parent childs size = 1.
	child := parent childs at: 1.
	self should: (parent = child parent).
	"Getter returns copied list"
	result := parent childs.
	result remove: child.
	self should: result size = 0.
	self should: parent childs size = 1.
	"Remove child from parent"
	parent removeChild: child.
	self should: parent childs size = 0.
	self should: (child parent = nil).! !

TestCase subclass: #RelationshipTestNoSetUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Relationships-Tests'!

!RelationshipTestNoSetUp methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 15:04:32.121'!
testWithMissingParameters	
	| result |
	"Try to create a relationship with only one class. This should fail."
	result := OneToManyRelationship new.
	result leftClass: Parent.
	"self should: raise"[result activate.] on: Error do: [^nil].
	self should: [false].! !

!RelationshipTestNoSetUp methodsFor: 'as yet unclassified' stamp: 'cn 1/6/2011 14:51:41.071'!
testWithNames	
	| relationship parent |
	"Create relationship"
	relationship := OneToManyRelationship newWithName: 'maleChildren' leftClass: Parent rightClass: Child.
	relationship isBidirectional: true.
	relationship leftClassName: 'father'.
	relationship rightClassName: 'son'.
	relationship activate.
	"Try relationship"
	parent := Parent new.
	parent addSon: Child new.
	parent addSon: Child new.
	self should: [parent sons size = 2].
	self should: [(parent sons at: 1) father = parent].
	relationship remove.! !

!Class methodsFor: '*relationships' stamp: 'cn 12/23/2010 22:44:25.834'!
addRelationship: aRelationship
	relationships ifNil: [relationships := Dictionary new].
	relationships at: aRelationship relationshipName asSymbol put: aRelationship.! !

!Class methodsFor: '*relationships' stamp: 'cn 12/23/2010 23:43:50.418'!
relationships
	"Answer the value of relationships"
	relationships ifNil: [relationships := Dictionary new].
	^ relationships! !

!Class methodsFor: '*relationships' stamp: 'cn 12/8/2010 23:56'!
removeRelationship: aRelationship
	relationships ifNil: [relationships := Dictionary new].
	relationships removeKey: (aRelationship relationshipName).! !
